## mingw-w64-scotch-7.0.7-1.src.tar.zst

=== src/CMakeLists.txt ===
## Copyright 2014-2016,2021-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                Cedric LACHAT (v6.0)                    ##
##                Amaury JACQUES (v6.0)                   ##
##                Clement BARTHELEMY                      ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     28 jan 2025     ##
##                                                        ##
############################################################

# Add general compiler options
add_definitions(-Drestrict=__restrict -DSCOTCH_RENAME)

set(dev_null /dev/null)

# Add OS-specific compiler options
if(APPLE)
  add_definitions(-DCOMMON_OS_MACOS -D_DARWIN_C_SOURCE)
endif(APPLE)
if(MINGW OR MSYS OR WIN32)
  add_definitions(-DCOMMON_OS_WINDOWS)
  set(dev_null NUL)
endif(MINGW OR MSYS OR WIN32)
if(MSVC)
  add_definitions(-D_CRT_NONSTDC_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# Detect FreeBSD
if(${CMAKE_HOST_SYSTEM_NAME}} MATCHES "^.*FreeBSD.*$")
  set(OS_IS_FREEBSD ON)
  message(STATUS "OS is FreeBSD")
endif()

###################
#  Prerequisites  #
###################

# Bison
find_package(BISON)
if(NOT BISON_FOUND)
  message(FATAL_ERROR "Bison required to compile Scotch and PT-Scotch")
else()
  message(STATUS "Bison found here: ${BISON_EXECUTABLE}")
endif()

# Flex
find_package(FLEX)
if(NOT FLEX_FOUND)
  message(FATAL_ERROR "Flex required to compile Scotch and PT-Scotch")
else()
  message(STATUS "Flex found here: ${FLEX_EXECUTABLE}")
endif()

if(WIN32)
  set(FLEX_FLAG "--wincompat")
else()
  set(FLEX_FLAG "")
endif()

#############
#  Options  #
#############

# Set integer size
if(NOT INTSIZE STREQUAL "")
  if(INTSIZE STREQUAL "32")
    message(STATUS "Integer size is 32 bits")
    add_definitions(-DINTSIZE32)
  elseif(INTSIZE STREQUAL "64")
    message(STATUS "Integer size is 64 bits")
    add_definitions(-DINTSIZE64)
  else()
    message(FATAL_ERROR "Invalid integer size value")
  endif()
endif()

# Thread support in Scotch
if(THREADS)
  find_package(Threads)
  if(Threads_FOUND)
    add_definitions(-DCOMMON_PTHREAD -DSCOTCH_PTHREAD)
  endif()
  if(CMAKE_USE_WIN32_THREADS_INIT)
    add_definitions(-DCOMMON_THREAD_WIN32)
  endif()
  include(CheckPthreadAffinity)
  if(PTHREAD_AFFINITY_LINUX_OK)
    add_definitions(-DCOMMON_PTHREAD_AFFINITY_LINUX)
  endif()
endif()

# Detect and remove GCC _FORTIFY_SOURCE
if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  execute_process(COMMAND ${CMAKE_C_COMPILER} ${CMAKE_C_FLAGS} -E -Og -dM -x c ${dev_null} OUTPUT_VARIABLE gcc_macros)
  string(FIND ${gcc_macros} "_FORTIFY_SOURCE" fortify)
  if(fortify GREATER -1)
    message(WARNING "GCC _FORTIFY_SOURCE is known to cause problem with Scotch and has been disabled")
    set(CMAKE_C_FLAGS "-U_FORTIFY_SOURCE ${CMAKE_C_FLAGS}")
  endif()
endif()

# Decompression libs
if(USE_ZLIB)
  find_package(ZLIB)
endif(USE_ZLIB)

if (USE_BZ2)
  find_package(BZip2)
endif (USE_BZ2)

if (USE_LZMA)
  find_package(LibLZMA)
endif(USE_LZMA)

# MPI
if(BUILD_PTSCOTCH)
  set(MPI_DETERMINE_LIBRARY_VERSION ON)
  find_package(MPI COMPONENTS C)
  if(NOT MPI_C_FOUND)
    message(FATAL_ERROR "MPI required to compile PT-Scotch\n Rerun cmake with -DBUILD_PTSCOTCH=OFF")
  else()
    string(REGEX MATCHALL "\( Open MPI \)+" found_suite ${MPI_C_LIBRARY_VERSION_STRING})
    if(NOT ${found_suite} STREQUAL "")
      message(STATUS "Found OpenMPI: using '--oversubscribe' policy for testing")
      set(MPIEXEC_PREFLAGS ${MPIEXEC_PREFLAGS} --oversubscribe)
    endif()
    string(REGEX MATCHALL "\(Intel\)+" found_suite ${MPI_C_LIBRARY_VERSION_STRING})
    if(NOT ${found_suite} STREQUAL "")
      message(STATUS "Found Intel MPI: using '-genv=I_MPI_PIN_DOMAIN=core' for testing")
      set(MPIEXEC_PREFLAGS ${MPIEXEC_PREFLAGS} -genv=I_MPI_PIN_DOMAIN=core)
    endif()
  endif()

  if(MPI_THREAD_MULTIPLE)
    if(Threads_FOUND)
      include(CheckMpiThreadMultiple)
      if(MPI_THREAD_MULTIPLE_OK)
        message(STATUS "MPI implementation DOES support MPI_THREAD_MULTIPLE")
        add_definitions(-DSCOTCH_PTHREAD_MPI)
      else()
        message(STATUS "MPI implementation does NOT support MPI_THREAD_MULTIPLE")
      endif()
    endif()
  endif()
endif(BUILD_PTSCOTCH)

# Put libraries in the lib subdirectory
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

# Put executables in the bin subdirectory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Set variables for include directories
set(GENERATED_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/include)
set(LIBSCOTCH_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libscotch)
file(MAKE_DIRECTORY ${GENERATED_INCLUDE_DIR})

# Build Scotch and PT-Scotch libraries
add_subdirectory(libscotch)

# Build Scotch executables
add_subdirectory(scotch)

# Build EsMUMPS library
if(BUILD_LIBESMUMPS)
  add_subdirectory(esmumps)
endif(BUILD_LIBESMUMPS)

# Build ScotchMeTiS library
if(BUILD_LIBSCOTCHMETIS)
  add_subdirectory(libscotchmetis)
endif(BUILD_LIBSCOTCHMETIS)

# Testing
if(ENABLE_TESTS)
  add_subdirectory(check)
endif(ENABLE_TESTS)

####################
#  Export targets  #
####################

# See https://cmake.org/cmake/help/latest/module/CMakePackageConfigHelpers.html
include(CMakePackageConfigHelpers)

configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/SCOTCHConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/scotch
  PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR)

write_basic_package_version_file(SCOTCHConfigVersion.cmake
  VERSION ${SCOTCH_VERSION_LONG}
  COMPATIBILITY AnyNewerVersion)

# Install config files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfigVersion.cmake
  COMPONENT libscotch
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/scotch)

=== src/libscotch/CMakeLists.txt ===
## Copyright 2014-2016,2021-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     10 jan 2025     ##
##                                                        ##
############################################################

################
#  dummysizes  #
################

add_executable(dummysizes dummysizes.c)
set_target_properties(dummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
if(BUILD_PTSCOTCH)
  find_package(MPI COMPONENTS C)
  if(NOT MPI_C_FOUND)
    message(FATAL_ERROR "MPI required to compile PT-Scotch")
  endif()
  add_executable(ptdummysizes dummysizes.c)
  set_target_properties(ptdummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(ptdummysizes PRIVATE MPI::MPI_C)
  add_dependencies(ptdummysizes scotch_h)
  set_target_properties(ptdummysizes PROPERTIES
    COMPILE_FLAGS -DSCOTCH_PTSCOTCH)
endif()

##############
#  scotch.h  #
##############

# Generate scotch.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotch.h
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library.h ${GENERATED_INCLUDE_DIR}/scotch.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotch.h")
add_custom_target(scotch_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotch.h")

# Generate scotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotchf.h
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library_f.h ${GENERATED_INCLUDE_DIR}/scotchf.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotchf.h")
add_custom_target(scotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotchf.h")

################
#  ptscotch.h  #
################

# Generate ptscotch.h
if(BUILD_PTSCOTCH)
  add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotch.h
    COMMAND $<TARGET_FILE:ptdummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library_pt.h ${GENERATED_INCLUDE_DIR}/ptscotch.h DEPENDS ptdummysizes
    DEPENDS library_pt.h scotch_h
    COMMENT "Generate ptscotch.h")
  add_custom_target(ptscotch_h
    DEPENDS ${GENERATED_INCLUDE_DIR}/ptscotch.h)

# Generate ptscotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotchf.h
  COMMAND $<TARGET_FILE:ptdummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library_pt_f.h ${GENERATED_INCLUDE_DIR}/ptscotchf.h DEPENDS ptdummysizes
  DEPENDS library.h
  COMMENT "Generate ptscotchf.h")
add_custom_target(ptscotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/ptscotchf.h")
endif()

#################
#  parser_yy.c  #
#################

# Generate parser_yy.c using Bison
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h
  COMMAND ${BISON_EXECUTABLE} "-pscotchyy${SCOTCH_NAME_SUFFIX}" --defines="parser_ly.h" --output="parser_yy.c" ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y module.h common.h parser.h parser_yy.h
  COMMENT "Generate parser_yy.c and parser_ly.h using Bison")
add_custom_target(parser_yy_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h)

#################
#  parser_ll.c  #
#################

# Generate parser_ll.c using Flex
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c
  COMMAND ${FLEX_EXECUTABLE} "-Pscotchyy${SCOTCH_NAME_SUFFIX}"  "-oparser_ll.c" ${CMAKE_CURRENT_SOURCE_DIR}/parser_ll.l
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parser_ll.l module.h common.h parser.h parser_ll.h parser_ly.h
  COMMENT "Generate parser_ll.c using Flex")
add_custom_target(parser_ll_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c)

###############
#  libScotch  #
###############

set(SCOTCH_C_SOURCES
  arch.c
  arch.h
  arch_build.c
  arch_build.h
  arch_build2.c
  arch_build2.h
  arch_cmplt.c
  arch_cmplt.h
  arch_cmpltw.c
  arch_cmpltw.h
  arch_deco.c
  arch_deco.h
  arch_deco2.c
  arch_deco2.h
  arch_dist.c
  arch_dist.h
  arch_hcub.c
  arch_hcub.h
  arch_mesh.c
  arch_mesh.h
  arch_tleaf.c
  arch_tleaf.h
  arch_sub.c
  arch_sub.h
  arch_torus.c
  arch_torus.h
  arch_vcmplt.c
  arch_vcmplt.h
  arch_vhcub.c
  arch_vhcub.h
  bgraph.c
  bgraph.h
  bgraph_bipart_bd.c
  bgraph_bipart_bd.h
  bgraph_bipart_df.c
  bgraph_bipart_df.h
  bgraph_bipart_ex.c
  bgraph_bipart_ex.h
  bgraph_bipart_fm.c
  bgraph_bipart_fm.h
  bgraph_bipart_gg.c
  bgraph_bipart_gg.h
  bgraph_bipart_gp.c
  bgraph_bipart_gp.h
  bgraph_bipart_ml.c
  bgraph_bipart_ml.h
  bgraph_bipart_st.c
  bgraph_bipart_st.h
  bgraph_bipart_zr.c
  bgraph_bipart_zr.h
  bgraph_cost.c
  bgraph_check.c
  bgraph_cost.c
  bgraph_store.c
  common.c
  common.h
  common_context.c
  common_error.c
  common_file.c
  common_file.h
  common_file_compress.c
  common_file_compress.h
  common_file_decompress.c
  common_integer.c
  common_memory.c
  common_string.c
  common_stub.c
  common_thread.c
  common_thread_system.c
  common_thread_system.h
  common_timer.c
  common_timer.h
  common_values.c
  common_values.h
  context.c
  context.h
  fibo.c
  fibo.h
  gain.c
  gain.h
  geom.c
  geom.h
  graph.c
  graph.h
  graph_band.c
  graph_base.c
  graph_check.c
  graph_clone.c
  graph_coarsen.c
  graph_coarsen.h
  graph_diam.c
  graph_ielo.c
  library_graph_induce.c
  graph_induce.c
  graph_induce.h
  graph_io.c
  graph_io.h
  graph_io_chac.c
  graph_io_habo.c
  graph_io_habo.h
  graph_io_mmkt.c
  graph_io_mmkt.h
  graph_io_scot.c
  graph_io_scot.h
  graph_list.c
  graph_list.h
  graph_match.c
  graph_match.h
  hall_order_hd.c
  hall_order_hd.h
  hall_order_hf.c
  hall_order_hf.h
  hall_order_hx.c
  hall_order_hx.h
  hgraph.c
  hgraph.h
  hgraph_check.c
  hgraph_induce.c
  hgraph_induce.h
  hgraph_order_bl.c
  hgraph_order_bl.h
  hgraph_order_cc.c
  hgraph_order_cc.h
  hgraph_order_cp.c
  hgraph_order_cp.h
  hgraph_order_gp.c
  hgraph_order_gp.h
  hgraph_order_hd.c
  hgraph_order_hd.h
  hgraph_order_hf.c
  hgraph_order_hf.h
  hgraph_order_hx.c
  hgraph_order_hx.h
  hgraph_order_kp.c
  hgraph_order_kp.h
  hgraph_order_nd.c
  hgraph_order_nd.h
  hgraph_order_si.c
  hgraph_order_si.h
  hgraph_order_st.c
  hgraph_order_st.h
  hmesh.c
  hmesh.h
  hmesh_check.c
  hmesh_hgraph.c
  hmesh_hgraph.h
  hmesh_induce.c
  hmesh_mesh.c
  hmesh_order_bl.c
  hmesh_order_bl.h
  hmesh_order_cp.c
  hmesh_order_cp.h
  hmesh_order_gp.c
  hmesh_order_gp.h
  hmesh_order_gr.c
  hmesh_order_gr.h
  hmesh_order_hd.c
  hmesh_order_hd.h
  hmesh_order_hf.c
  hmesh_order_hf.h
  hmesh_order_hx.c
  hmesh_order_hx.h
  hmesh_order_nd.c
  hmesh_order_nd.h
  hmesh_order_si.c
  hmesh_order_si.h
  hmesh_order_st.c
  hmesh_order_st.h
  kgraph.c
  kgraph.h
  kgraph_band.c
  kgraph_check.c
  kgraph_cost.c
  kgraph_map_bd.c
  kgraph_map_bd.h
  kgraph_map_cp.c
  kgraph_map_cp.h
  kgraph_map_df.c
  kgraph_map_df.h
  kgraph_map_ex.c
  kgraph_map_ex.h
  kgraph_map_fm.c
  kgraph_map_fm.h
  kgraph_map_ml.c
  kgraph_map_ml.h
  kgraph_map_rb.c
  kgraph_map_rb.h
  kgraph_map_rb_map.c
  kgraph_map_rb_map.h
  kgraph_map_rb_part.c
  kgraph_map_rb_part.h
  kgraph_map_st.c
  kgraph_map_st.h
  kgraph_store.c
  library.h
  library_arch.c
  library_arch_build.c
  library_arch_build_f.c
  library_arch_dom.c
  library_arch_dom_f.c
  library_arch_f.c
  library_common.c
  library_common_f.c
  library_context.c
  library_context_graph.c
  library_context_graph_f.c
  library_context_f.c
  #library_errcom.c
  #library_error.c
  #library_error_exit.c
  library_f.h
  library_geom.c
  library_geom_f.c
  library_graph.c
  library_graph_base.c
  library_graph_base_f.c
  library_graph_check.c
  library_graph_check_f.c
  library_graph_coarsen.c
  library_graph_coarsen_f.c
  library_graph_color.c
  library_graph_color_f.c
  library_graph_diam.c
  library_graph_diam_f.c
  library_graph_f.c
  library_graph_io_chac.c
  library_graph_io_chac_f.c
  library_graph_io_habo.c
  library_graph_io_habo_f.c
  library_graph_io_mmkt.c
  library_graph_io_mmkt_f.c
  library_graph_io_scot.c
  library_graph_io_scot_f.c
  library_graph_map.c
  library_graph_map_f.c
  library_graph_map_io.c
  library_graph_map_io.h
  library_graph_map_io_f.c
  library_graph_map_view.c
  library_graph_map_view.h
  library_graph_map_view_f.c
  library_graph_order.c
  library_graph_order_f.c
  library_graph_part_ovl.c
  library_graph_part_ovl_f.c
  library_mapping.c
  library_mapping.h
  library_memory.c
  library_mesh.c
  library_mesh_f.c
  library_mesh_graph.c
  library_mesh_graph_f.c
  library_mesh_io_habo.c
  library_mesh_io_habo_f.c
  library_mesh_io_scot.c
  library_mesh_io_scot_f.c
  library_mesh_order.c
  library_mesh_order_f.c
  library_order.c
  library_order.h
  library_parser.c
  library_parser_f.c
  library_pt.h
  library_pt_f.h
  library_random.c
  library_random_f.c
  library_strat.c
  library_version.c
  library_version_f.c
  mapping.c
  mapping.h
  mapping_check.c
  mapping_io.c
  mapping_io.h
  mesh.c
  mesh.h
  mesh_check.c
  mesh_coarsen.c
  mesh_coarsen.h
  mesh_graph.c
  mesh_graph.h
  mesh_induce_sepa.c
  mesh_induce_sepa.h
  mesh_io.c
  mesh_io.h
  mesh_io_habo.c
  mesh_io_scot.c
  module.h
  order.c
  order.h
  order_check.c
  order_io.c
  parser.c
  parser.h
  ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c
  ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h
  ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c
  parser_yy.h
  ${GENERATED_INCLUDE_DIR}/scotch.h
  vgraph.c
  vgraph.h
  vgraph_check.c
  vgraph_separate_bd.c
  vgraph_separate_bd.h
  vgraph_separate_df.c
  vgraph_separate_df.h
  vgraph_separate_es.c
  vgraph_separate_es.h
  vgraph_separate_fm.c
  vgraph_separate_fm.h
  vgraph_separate_gg.c
  vgraph_separate_gg.h
  vgraph_separate_gp.c
  vgraph_separate_gp.h
  vgraph_separate_ml.c
  vgraph_separate_ml.h
  vgraph_separate_st.c
  vgraph_separate_st.h
  vgraph_separate_th.c

=== PKGBUILD ===
# Contributor: Oleg A. Khlybov <fougas@mail.ru>

_realname=scotch
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-int64")
pkgdesc='Graph partitioning and sparse matrix ordering package (mingw-w64)'
pkgver=7.0.7
pkgrel=1
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.labri.fr/perso/pelegrin/scotch/"
msys2_repository_url="https://gitlab.inria.fr/scotch/scotch"
license=('spdx:CECILL-C')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-libsystre"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi"))
options=('!strip')
source=("https://gitlab.inria.fr/scotch/scotch/-/archive/v${pkgver}/${_realname}-v${pkgver}.tar.gz"
        "Makefile.idx32.inc"
        "Makefile.idx64.inc"
        "0002-pipe-fix.patch"
        "0004-dummysizes-regex.patch"
        "0005-gcc15.patch")
sha256sums=('02084471d2ca525f8a59b4bb8c607eb5cca452d6a38cf5c89f5f92f7edc1a5b5'
            '4221b69dcc53230ff4d6bc18e3982f6d39971a99fc17f4dab609fc19b99d8a30'
            'c52bf0598332d8139a37606e7ea9376b7f841059047c0c977b205a763fc7e97a'
            'b6e76b1d2f35b3fcc771b97a35a468d6314ee3a619defef18b82fc7654638a49'
            '15dd82d4c7b118e08316df4242d647bdaa1f180ff143ee33fe84633c97aac111'
            '5e9f80eccaca1619ffa279c544c9601731748d852c02f1873b0556bebf625804')

prepare() {
  cd "${srcdir}/${_realname}-v${pkgver}"
  for p in ${source[*]:3}; do
    patch -p1 -i "$srcdir/$p"
  done
}

_build_scotch() {
  _idx_makefile_inc=$1
  _idx_suffix=$2

  cp -r "${srcdir}/${_realname}-v${pkgver}" "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}"
  cd "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}"

  cp -p "${srcdir}/${_idx_makefile_inc}" "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}/src/Makefile.inc"
  cd "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}/src"

  if [[ ${CARCH} != aarch64 ]]; then
    make scotch ptscotch esmumps ptesmumps
  else
    # No MPI so no PT-Scotch
    make scotch esmumps 
  fi

  cd ../lib
  ${CC} -shared -o lib${_realname}.dll -Wl,--enable-auto-import -Wl,--export-all-symbols,-no-undefined \
    -Wl,--out-implib,lib${_realname}.dll.a -Wl,--whole-archive lib${_realname}.a lib${_realname}err.a -Wl,--no-whole-archive \
    -pthread

  mv "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}/include/metis.h" "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}/include/scotchmetis.h"

  if [[ ${CARCH} != aarch64 ]]; then
    mpicc -shared -o libpt${_realname}.dll -Wl,--enable-auto-import -Wl,--export-all-symbols,-no-undefined \
      -Wl,--out-implib,libpt${_realname}.dll.a -Wl,--whole-archive libpt${_realname}.a libpt${_realname}err.a -Wl,--no-whole-archive \
      -L. -l${_realname} -pthread

    mv "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}/include/parmetis.h" "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}/include/ptscotchparmetis.h"
  fi
}

build()
{
  msg2 "Build Scotch with 32-bit indexing"
  _build_scotch "Makefile.idx32.inc" "32"

  msg2 "Build Scotch with 64-bit indexing"
  _build_scotch "Makefile.idx64.inc" "64"
}


_package_scotch() {
  _idx_suffix=$1

  cd "${srcdir}/${_realname}-v${pkgver}"
  mkdir -p "${pkgdir}"${MINGW_PREFIX}/{bin,lib,include}
  mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/pkgconfig"
  echo "
	prefix=${MINGW_PREFIX}
	libdir=\${prefix}/lib
	includedir=\${prefix}/include
	Name: scotch
	URL: ${url}
	Version: ${pkgver}
	Description: Serial graph partitioning and sparse matrix ordering package
	Cflags: -I\${includedir}
	Libs.private: -lscotcherr
	Libs: -L\${libdir} -lscotch
  " | sed '/^\s*$/d;s/^\s*//' > "${pkgdir}${MINGW_PREFIX}/lib/pkgconfig/scotch.pc"

  if [[ ${CARCH} != aarch64 ]]; then
    echo "
    prefix=${MINGW_PREFIX}
    libdir=\${prefix}/lib
    includedir=\${prefix}/include
    Name: ptscotch
    URL: ${url}
    Version: ${pkgver}
    Description: Parallel graph partitioning and sparse matrix ordering package
    Requires: scotch
    Requires.private: msmpi
    Cflags: -I\${includedir}
    Libs.private: -lptscotcherr
    Libs: -L\${libdir} -lptscotch
    " | sed '/^\s*$/d;s/^\s*//' > "${pkgdir}${MINGW_PREFIX}/lib/pkgconfig/ptscotch.pc"
  fi  
  (
    cd "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}"/include
    install -m644 *.h "${pkgdir}${MINGW_PREFIX}/include"
  )
  (
    cd "${srcdir}/build-${MSYSTEM}-idx${_idx_suffix}"/lib
    install -m644 lib*.a "${pkgdir}${MINGW_PREFIX}/lib"
    install -m644 lib*.dll "${pkgdir}${MINGW_PREFIX}/bin"
  )
}

package_scotch()
{
  _package_scotch "32"
}

package_scotch-int64() {
  pkgdesc="Graph partitioning and sparse matrix ordering package with 64-bit indexing (mingw-w64)"
  conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}")
  _package_scotch "64"
}


# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
